zoukankan      html  css  js  c++  java
  • POJ 2923 状压好题

    Relocation
    Time Limit: 1000MS   Memory Limit: 65536K
    Total Submissions: 2631   Accepted: 1075

    Description

    Emma and Eric are moving to their new house they bought after returning from their honeymoon. Fortunately, they have a few friends helping them relocate. To move the furniture, they only have two compact cars, which complicates everything a bit. Since the furniture does not fit into the cars, Eric wants to put them on top of the cars. However, both cars only support a certain weight on their roof, so they will have to do several trips to transport everything. The schedule for the move is planed like this:

    1. At their old place, they will put furniture on both cars.
    2. Then, they will drive to their new place with the two cars and carry the furniture upstairs.
    3. Finally, everybody will return to their old place and the process continues until everything is moved to the new place.

    Note, that the group is always staying together so that they can have more fun and nobody feels lonely. Since the distance between the houses is quite large, Eric wants to make as few trips as possible.

    Given the weights wi of each individual piece of furniture and the capacities C1 and C2 of the two cars, how many trips to the new house does the party have to make to move all the furniture? If a car has capacity C, the sum of the weights of all the furniture it loads for one trip can be at most C.

    Input

    The first line contains the number of scenarios. Each scenario consists of one line containing three numbers nC1 and C2C1 and C2 are the capacities of the cars (1 ≤ Ci ≤ 100) and n is the number of pieces of furniture (1 ≤ n ≤ 10). The following line will contain n integers w1, …, wn, the weights of the furniture (1 ≤ wi ≤ 100). It is guaranteed that each piece of furniture can be loaded by at least one of the two cars.

    Output

    The output for every scenario begins with a line containing “Scenario #i:”, where i is the number of the scenario starting at 1. Then print a single line with the number of trips to the new house they have to make to move all the furniture. Terminate each scenario with a blank line.

    Sample Input

    2
    6 12 13
    3 9 13 3 10 11
    7 1 100
    1 2 33 50 50 67 98

    Sample Output

    Scenario #1:
    2
    
    Scenario #2:
    3

    Source

    TUD Programming Contest 2006, Darmstadt, Germany
     
    题目意思:
    有两辆容量分别为c1和c2的车,有n个体积为v[i]的物品,现用车拉物品,最少用多少次把所有物品拉完。
     
    思路:
    状压物品,记录所有可以一次性拉的物品组合二进制状态,那么答案肯定是由这些记录过的状态组合而成的,dp即可。
     
    代码:
     1 #include <cstdio>
     2 #include <cstring>
     3 #include <algorithm>
     4 #include <iostream>
     5 #include <vector>
     6 #include <queue>
     7 #include <cmath>
     8 #include <set>
     9 using namespace std;
    10 
    11 #define N 100005
    12 #define inf 999999999
    13 
    14 int n, c1, c2;
    15 int w[15];
    16 int num[1050];
    17 
    18 bool solve(int nn){
    19     int i, j, k;
    20     int sum=0;
    21     bool visited[105];
    22     memset(visited,false,sizeof(visited));
    23     visited[0]=true;
    24     for(i=0;i<n;i++){
    25         if((1<<i)&nn){
    26             sum+=w[i];
    27             for(j=c1-w[i];j>=0;j--){//DP
    28                 if(visited[j])
    29                     visited[j+w[i]]=true;
    30             }
    31         }
    32     }
    33     for(i=0;i<=c1;i++){
    34         if(visited[i]&&sum-i<=c2)
    35             return true;
    36     }
    37     return false;
    38 }
    39 
    40 
    41 main()
    42 {
    43     int t, i, j, k;
    44     int kase=1;
    45     cin>>t;
    46     while(t--){
    47         scanf("%d %d %d",&n,&c1,&c2);
    48         for(i=0;i<n;i++) scanf("%d",&w[i]);
    49         int len=0;
    50         int cnt=(1<<n)-1;
    51         for(i=0;i<=cnt;i++){
    52             if(solve(i))
    53                 num[len++]=i;
    54         }
    55         int dp[1050];
    56         for(i=0;i<=cnt;i++) dp[i]=inf;
    57         dp[0]=0;
    58         for(i=0;i<len;i++){//DP
    59             for(j=cnt;j>=0;j--){
    60                 if(!(j&num[i])){
    61                     dp[j|num[i]]=min(dp[j|num[i]],dp[j]+1);
    62                 }
    63             }
    64         }
    65         printf("Scenario #%d:
    %d
    
    ",kase++,dp[cnt]);
    66     }
    67 }
  • 相关阅读:
    【杭电ACM】1.2.4 Financial Management
    【杭电ACM】1.2.1 Biker's Trip Odometer
    【杭电ACM】1097 A hard puzzle
    【西交ACM】100 A+B problem
    【杭电ACM】1.2.2 Climbing Worm
    【杭电ACM】1004 Let the Balloon Rise
    【杭电ACM】1.2.3 hide handkerchief
    【杭电ACM】1.2.5 find your present (2)
    【杭电ACM】1.2.6 decimal system
    【西交ACM】298 第N大的数
  • 原文地址:https://www.cnblogs.com/qq1012662902/p/4655691.html
Copyright © 2011-2022 走看看